#pragma once

class CVaxCall;
class CVaxTransfer;

class CVaxQueue;
class CVaxRingGroup;

class CVaxDTMF;
class CVaxRoom;

class CVaxDetectAMD;
class CVaxCallSessionRoute;

class CVaxAccessAudioPCM;

class CVaxCallSession
{

public:

	CVaxCallSession();
	~CVaxCallSession();

private:
	
	static CVaxCallSessionRoute* m_pRouteCallSIP;
	
	CVaxAccessAudioPCM* m_pAccessPCM;

	CVaxRoom* m_pVaxRoom;
	CVaxCall* m_pVaxCall;
	CVaxTransfer* m_pVaxTransfer;
	
	CVaxQueue* m_pVaxQueue;
	CVaxRingGroup* m_pVaxRingGroup;
		
	CVaxDTMF* m_pVaxDTMF;
	CVaxDetectAMD* m_pVaxAMD;
	
public:

	static void AddUserRoute(LPCTSTR sUserName, LPCTSTR sUserPrefix, LPCTSTR sDialPrefix, LPCTSTR sToPeerName);
	static void RemoveUserRoute(LPCTSTR sUserName);

	static void AddLineRoute(LPCTSTR sLineName, LPCTSTR sToPeerName, BOOL bRejected, LPCTSTR sRoomName, LPCTSTR sQueueName, LPCTSTR sRingGroupName);
	static void RemoveLineRoute(LPCTSTR sLineName);

	static void ResetAll(BOOL bAlloc, BOOL bDeAlloc);

private:

	void GetFromPeerRouteInfo(LONG nFromPeerType, LPCTSTR sFromPeerName, LPCTSTR sDialNo, CString& sDialToNo, CString& sToPeerName, BOOL& bRejected, CString& sRoomName, CString& sQueueName, CString& sRingGroupName);
	void OnProcessCall(LONG nSessionId, LPCTSTR sCallerName, LPCTSTR sCallerId, LPCTSTR sDialNo, LONG nFromPeerType, LPCTSTR sFromPeerName, LPCTSTR sUserAgentName, LPCTSTR sFromIP, LONG nFromPort, LPCTSTR sToPeerName, LPCTSTR sRoomName, LPCTSTR sQueueName, LPCTSTR sRingGroupName);

public:

	void OnCallSessionClosed(int nSessionId, int nChannelId, int nReasonCode);
	void OnIncomingCall(LONG nSessionId, LPCTSTR sCallerName, LPCTSTR sCallerId, LPCTSTR sDialNo, LONG nFromPeerType, LPCTSTR sFromPeerName, LPCTSTR sUserAgentName, LPCTSTR sFromIP, LONG nFromPort);
			
	void OnCallSessionTransferBlind(LONG nTransfererSessionId, LONG nTransfererChannelId, LPCTSTR sTransferer, LPCTSTR sTransferee, LPCTSTR sTransferTo);
	void OnCallSessionTransferConsult(LONG nTransfererSessionId, LONG nTransfererChannelId, LONG nTransferToSessionId, LONG nTransferToChannelId, LPCTSTR sTransferer, LPCTSTR sTransferee, LPCTSTR sTransferTo);

	void OnDetectedDigitDTMF(LONG nSessionId, LONG nChannelId, LPCTSTR sDigitDTMF);
	void OnCallSessionDetectedAMD(LONG nSessionId, LONG nChannelId, BOOL bIsHuman);
		
	void OnQueuePlayWaveStarted(LONG nEventType, LPCTSTR sQueueName, LONG nSessionId);
	void OnQueuePlayWaveEnded(LONG nEventType, LPCTSTR sQueueName, LONG nSessionId);

};

